// Keygen, Matrix generation & Keyfile generation for Genocide Trial Crackme
// by TSCube 23/04/2000

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

void generate_serial(const char* ,char*);
void generate_matrix(void);

int matrix[5][5];

int main(void)
{
	puts("Keygen, Matrix generation & Keyfile generation for Genocide Trial Crackme");
	puts("by TSCube 23/04/2000\n");

	puts("1 -> Keygen");
	puts("2 -> Matrix generation");
	puts("3 -> Keyfile generation");

	int choice;
	printf("Choose your destiny (1/2/3) : ");
	scanf("%d",&choice);
	printf("\n");
	fflush(stdin);

	if (choice==1)
	{
		char szName[50];
		char szSerial[50];

		printf ("Name (at least 6 letters, only letters, no spaces !) : ");
		gets(szName);
		_strupr(szName); // UPPERCASE

		if (strlen(szName)<5)
		{
			puts("Name must have a least 6 letters !");
			return 1;
		}

		generate_serial(szName,szSerial);		
		printf ("Serial : %s",szSerial);
	}


	if (choice==2)
	{
		generate_matrix();

		// display matrix :
		for (int line=0;line<5;line++)
		{
			for (int row=0;row<5;row++) 
			{
				printf("%02d ",matrix[line][row]);
			}
			printf("\n");
		}
	
	}

	if (choice==3)
	{
		FILE* keyfile;
		keyfile = fopen("gctrial.key","w");
		if (keyfile==NULL)
		{
			puts("Error while creating keyfile !");
			return 1;
		}
		fprintf(keyfile,"86?@4:56");
		fclose(keyfile);
		puts("Keyfile <gctrial.key> successfully created !");
	}

	puts("\n<enter> to finish");
	getchar();
	return 0;

}



// matrix generation routine (may take a while on slow PC)
void generate_matrix(void)
{
	int sum;
	srand( (unsigned)time( NULL ));

	do
	{
		// initialise matrix with random numbers between 0 & 100 :
		for (int line=0;line<5;line++)
		{
			for (int row=0;row<5;row++)
			{
				matrix[line] [row] = rand() % 100;
			}
		}

		// stores constant numbers :
		matrix[0][1] = 24;
		matrix[1][4] = 10;
		matrix[1][1] = 80;
		matrix[2][0] = 63;
		matrix[1][2] = 53;
		matrix[3][3] = 21;

		// compute sum of matrix elements :
		sum=0;
		for (line=0;line<5;line++)
		{
			for (int row=0;row<5;row++)
			{
				sum = sum + matrix[line][row];
			}
		}

		sum = sum - matrix[4][4]; // substracts last element
	}
	while ( (sum<1341-100) || (sum>1341));

	matrix[4][4] = 1341 - sum; // stores last elements so that sum = 1341

}




void generate_serial(const char* szName,char* szSerial)
{
	char szMagic1[20];

	// computes name's unlock code :
	unsigned int tmp=0;
	int ebpm19 = strlen(szName) / 2;
	for (int i =ebpm19;i>0;i--)
	{
		char res = szName[tmp] ^ szName[ebpm19 + tmp];
		if (res>0x0A) res = res / 0x0A;
		szMagic1[tmp]=res+0x30;
		tmp++;
	}
	szMagic1[tmp]=0x00;


	// computes correct serial :
	for (tmp=0;tmp<strlen(szMagic1);tmp++) szSerial[tmp] = '0';
	szSerial[tmp]=0x00;
	strcat(szSerial,szMagic1);
}